<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Static Pages Plugin 1.2 for Geeklog - The Ultimate Weblog                 |
// +---------------------------------------------------------------------------+
// | install.php                                                               |
// |                                                                           |
// | This file installs and removes the data structures for the Static Pages   |
// | plugin for Geeklog.                                                       |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Authors: Tony Bibbs       - tony@tonybibbs.com                            |
// |          Tom Willett      - tomw@pigstye.net                              |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//
// $Id: install.php,v 1.2 2002/04/23 04:22:03 mlimburg Exp $

require_once('../../../lib-common.php');
$langfile = $_CONF['path'] . 'plugins/staticpages/language/' . $_CONF['language'] . '.php';

if (file_exists ($langfile)) {
    include ($langfile);
} else {
    include ($_CONF['path'] . 'plugins/staticpages/language/english.php');
}

include($_CONF['path'] . 'plugins/staticpages/config.php');

// Only let Root users access this page
if (!SEC_inGroup('Root')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Static Pages install/uninstall page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_STATIC['access_denied']);
    $display .= $LANG_STATIC['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter();
    echo $display;
    exit;
}
 
function upgrade(){
global $_TABLES, $_CONF;

    COM_errorLog('Attempting to upgrade the Static Page Plugin to V1.1',1);

    // Upgrades the static pages plugin

	$upgradesql = "ALTER TABLE " . $_TABLES['staticpage'] . " ADD COLUMN sp_pos int(4) unsigned DEFAULT '0' NOT NULL,";
	$upgradesql .= " ADD COLUMN group_id mediumint(8) unsigned DEFAULT '1' NOT NULL,";
    $upgradesql .= " ADD COLUMN owner_id mediumint(8) unsigned DEFAULT '1' NOT NULL,";
	$upgradesql .= " ADD COLUMN perm_owner tinyint(1) unsigned DEFAULT '3' NOT NULL,";
	$upgradesql .= " ADD COLUMN perm_group tinyint(1) unsigned DEFAULT '3' NOT NULL,";
	$upgradesql .= " ADD COLUMN perm_members tinyint(1) unsigned DEFAULT '2' NOT NULL,";
	$upgradesql .= " ADD COLUMN perm_anon tinyint(1) unsigned DEFAULT '2' NOT NULL,";
	$upgradesql .= " ADD COLUMN sp_php tinyint(1) unsigned DEFAULT '0' NOT NULL,";
	$upgradesql .= " ADD COLUMN sp_search_keywords text";
	com_errorlog("$upgradesql",1);
	DB_query($upgradesql,1);
	
	COM_errorLog('Registering Static Page plugin with Geeklog', 1);
    DB_delete($_TABLES['plugins'],'pi_name','staticpages');
    DB_query("INSERT INTO {$_TABLES['plugins']} (pi_name, pi_version, pi_gl_version, pi_homepage, pi_enabled) "
        . "VALUES ('staticpages', '1.2', '1.3.6', 'http://www.tonybibbs.com', 1)");
    
    COM_errorLog('Creating static.PHP feature', 1);
    DB_query("INSERT INTO {$_TABLES['features']} (ft_name, ft_descr) "
        . "VALUES ('staticpages.PHP','Ability to enable PHP evaluation of static pages.')",1);
    $PHP_id = DB_insertId();
    $grp_id = DB_getItem($_TABLES['vars'], 'value', "name = 'sp_group_id'");
    COM_errorLog('Attempting to give Static Page Admin group access to staticpages.PHP feature',1);
    DB_query("INSERT INTO {$_TABLES['access']} (acc_ft_id, acc_grp_id) VALUES ($PHP_id, $grp_id)");

    if (DB_error()) {
        return false;
    }else{
		COM_errorLog('...success',1);
		return true;
	}
}


/* 
* MAIN
*/


$display = COM_siteHeader();

if (DB_count($_TABLES['vars'], 'name', 'staticpages') == 0) {
    // Record in vars table doesn' exist
    $display .= COM_startBlock($LANG_STATIC['installation_failed']);
    $display .= $LANG_STATIC['installation_failed_msg'];
    $display .= COM_endBlock();
} else {
    // This plugin is installed, see if it is locked or not
    if(upgrade()){
	    //Upgrade Plugin to V1.2
	    $display .= COM_startBlock($LANG_STATIC['upgrade_completed']);
   	    $display .= $LANG_STATIC['upgrade_completed_msg'];
       	$display .= COM_endBlock();
	}else{
   		//Upgrade Plugin to V1.2 failed
		$display .= COM_startBlock($LANG_STATIC['upgrade_failed']);
   	    $display .= $LANG_STATIC['upgrade_failed_msg'];
       	$display .= COM_endBlock();
	}
}

$display .= COM_siteFooter();
echo $display;

?>
